--- chan_unistim.c	2007-05-13 14:52:20.000000000 -0400
+++ /usr/src/chan_unistim-1.0.0.5c/chan_unistim.c	2007-08-31 16:07:04.000000000 -0400
@@ -5471,14 +5471,17 @@
                         unload_module();
                         free(buff);
                         return AST_MODULE_LOAD_FAILURE;
-                }
+                } 
 
                 ast_rtp_proto_register(&unistim_rtp);
                 ast_cli_register_multiple(unistim_cli,sizeof(unistim_cli) / sizeof(unistim_cli[0]));
 
                 restart_monitor();
-        }
-        return 0;
+        	return 0;
+        } else {
+		ast_log(LOG_WARNING, "no conf file\n");
+		return AST_MODULE_LOAD_DECLINE;	
+	}
 }
 
 static int __unload_module(void)
@@ -5493,9 +5496,10 @@
         /* Hangup all device with active sessions, delete lines then devices ?*/
 
         if (!ast_mutex_lock(&monlock)) {
-                if (monitor_thread && (monitor_thread != AST_PTHREADT_STOP)) {
+		if (monitor_thread && (monitor_thread != AST_PTHREADT_STOP) && (monitor_thread != AST_PTHREADT_NULL)) {
                         pthread_cancel(monitor_thread);
                         pthread_kill(monitor_thread, SIGURG);
+			pthread_join(monitor_thread, NULL);
                 }
                 monitor_thread = AST_PTHREADT_STOP;
                 ast_mutex_unlock(&monlock);
